
TYPO3.Flow - Bug # 34154

Status: Resolved Priority: Must have
Author: Kira Backes Category: Validation
Created: 2012-02-21 Assigned To: Rens Admiraal
Updated: 2012-05-08 Due date:
PHP Version:
Has patch: No
Complexity:
Affected Flow version: Git master
Subject: ObjectValidator has exponential growth factor
Description

In the onFlush method of the PersistenceManager all objects are validates, this is a problem especially for many connected entities.
Look at the times needed:

Validate Insertion Count: 174
onFlush Validation Duration: 9s

Validate Insertion Count: 234
onFlush Validation Duration: 43s

Validate Insertion Count: 246
onFlush Validation Duration: 129s

At about 300 entities this is already taking hours to validate, so the system is completely unusable.

Related issues:
related to TYPO3.Flow - Bug # 37363: PersistenceManager->validateObject() ==>... Resolved 2012-05-21
duplicated by TYPO3.Flow - Bug # 34408: CollectionValidator goes in endless r... Closed 2012-02-29

Associated revisions
Revision 91a9590f - 2012-02-29 21:28 - Rens Admiraal

[TASK] Remove collection validation from Lazy collections

The change to validate collections introduced unwanted behavior
by validating lazy annotated and not yet initialized collections.
This basically disables lazy loading and introduces a major memory
problem.

Change-Id: Ib317803eba7d6ed04b067238e12b45698b6b0485
Related: #34154
Releases: 1.1

Revision 26e4b3fa - 2012-05-30 14:41 - Karsten Dambekalns

[BUGFIX] Avoid validating instances more often than needed

The GenericObjectValidator uses a static variable to store objects being
validated. Objects were still validated over and over because at the
end of isValid() they were detached again.

This change replaces that detach() call with another concept. Now
any validator implementing the new ObjectValidatorInterface can be
given an SplObjectStorage to keep track of instances already
validated.

If you reset that container when it makes sense (before you
actively validate objects) you can avoid validating single instances
more than once in one validation run but still validate at various
points on your logic flow.

If you have implemented your own object validator you should
implement the new ObjectValidatorInterface - the easiest way is
to extend the GenericObjectValidator, if you haven't done that
so far.

Change-Id: I7f437207e27593425b1fbdfc340a442e685a317f
Fixes: #37363
Related: #34154
Releases: 1.1, 1.2

Revision 632685da - 2012-05-30 15:06 - Karsten Dambekalns

[BUGFIX] Avoid validating instances more often than needed

The GenericObjectValidator uses a static variable to store objects being
validated. Objects were still validated over and over because at the
end of isValid() they were detached again.

This change replaces that detach() call with another concept. Now
any validator implementing the new ObjectValidatorInterface can be
given an SplObjectStorage to keep track of instances already
validated.

If you reset that container when it makes sense (before you
actively validate objects) you can avoid validating single instances
more than once in one validation run but still validate at various
points on your logic flow.

If you have implemented your own object validator you should
implement the new ObjectValidatorInterface - the easiest way is
to extend the GenericObjectValidator, if you haven't done that
so far.

Change-Id: I7f437207e27593425b1fbdfc340a442e685a317f
Fixes: #37363
Related: #34154
Releases: 1.1, 1.2
History
#1 - 2012-02-22 11:40 - Kira Backes

This also happens when loading a single entity with lots of connected entities (even when those entities are connected over 5 proxies, it seems like
everything is unfolded)

#2 - 2012-02-24 15:23 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9180

#3 - 2012-02-24 21:52 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9180

#4 - 2012-02-29 11:23 - Karsten Dambekalns
- Category set to Validation
- Assigned To set to Rens Admiraal
- Target version set to 1.1

#5 - 2012-05-08 16:16 - Karsten Dambekalns
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100
